/* gpx-parser-json.c generated by valac 0.56.17, the Vala compiler
 * generated from gpx-parser-json.vala, do not modify */

/* Gpx Viewer
 * Copyright (C) 2009-2015 Qball Cow <qball@sarine.nl>
 * Project homepage: http://blog.sarine.nl/

 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

#include "gpx.h"
#include <gio/gio.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>
#include <json-glib/json-glib.h>
#include <float.h>
#include <math.h>
#include <time.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	GPX_JSON_FILE_0_PROPERTY,
	GPX_JSON_FILE_NUM_PROPERTIES
};
static GParamSpec* gpx_json_file_properties[GPX_JSON_FILE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _gpx_point_unref0(var) ((var == NULL) ? NULL : (var = (gpx_point_unref (var), NULL)))

struct _GpxJsonFilePrivate {
	GFileInputStream* stream;
};

static gint GpxJsonFile_private_offset;
static gpointer gpx_json_file_parent_class = NULL;

static gint gpx_json_file_read_file (GpxJsonFile* self,
                              guint8* buffer,
                              gint buffer_length1);
static gint gpx_json_file_close_file (GpxJsonFile* self);
static void gpx_json_file_finalize (GObject * obj);
static GType gpx_json_file_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
gpx_json_file_get_instance_private (GpxJsonFile* self)
{
	return G_STRUCT_MEMBER_P (self, GpxJsonFile_private_offset);
}

static gint
gpx_json_file_read_file (GpxJsonFile* self,
                         guint8* buffer,
                         gint buffer_length1)
{
	gint _tmp3_ = -1;
	GError* _inner_error0_ = NULL;
	gint result;
	{
		gssize value = 0L;
		GFileInputStream* _tmp0_;
#line 36 "../gpx-viewer/libgpx/gpx-parser-json.vala"
		_tmp0_ = self->priv->stream;
#line 36 "../gpx-viewer/libgpx/gpx-parser-json.vala"
		value = g_input_stream_read ((GInputStream*) _tmp0_, buffer, (gsize) buffer_length1, NULL, &_inner_error0_);
#line 36 "../gpx-viewer/libgpx/gpx-parser-json.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 94 "gpx-parser-json.c"
			goto __catch0_g_error;
		}
#line 37 "../gpx-viewer/libgpx/gpx-parser-json.vala"
		result = (gint) value;
#line 37 "../gpx-viewer/libgpx/gpx-parser-json.vala"
		return result;
#line 101 "gpx-parser-json.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp1_;
		const gchar* _tmp2_;
#line 34 "../gpx-viewer/libgpx/gpx-parser-json.vala"
		e = _inner_error0_;
#line 34 "../gpx-viewer/libgpx/gpx-parser-json.vala"
		_inner_error0_ = NULL;
#line 41 "../gpx-viewer/libgpx/gpx-parser-json.vala"
		_tmp1_ = e;
#line 41 "../gpx-viewer/libgpx/gpx-parser-json.vala"
		_tmp2_ = _tmp1_->message;
#line 41 "../gpx-viewer/libgpx/gpx-parser-json.vala"
		g_critical ("gpx-parser-json.vala:41: error reading from stream: %s\n", _tmp2_);
#line 42 "../gpx-viewer/libgpx/gpx-parser-json.vala"
		result = -1;
#line 42 "../gpx-viewer/libgpx/gpx-parser-json.vala"
		_g_error_free0 (e);
#line 42 "../gpx-viewer/libgpx/gpx-parser-json.vala"
		return result;
#line 125 "gpx-parser-json.c"
	}
	__finally0:
#line 34 "../gpx-viewer/libgpx/gpx-parser-json.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 34 "../gpx-viewer/libgpx/gpx-parser-json.vala"
	g_clear_error (&_inner_error0_);
#line 34 "../gpx-viewer/libgpx/gpx-parser-json.vala"
	return _tmp3_;
#line 134 "gpx-parser-json.c"
}

static gint
gpx_json_file_close_file (GpxJsonFile* self)
{
	gint result;
#line 47 "../gpx-viewer/libgpx/gpx-parser-json.vala"
	g_log ("GPX PARSER", G_LOG_LEVEL_DEBUG, "gpx-parser-json.vala:47: Close_file()");
#line 48 "../gpx-viewer/libgpx/gpx-parser-json.vala"
	_g_object_unref0 (self->priv->stream);
#line 48 "../gpx-viewer/libgpx/gpx-parser-json.vala"
	self->priv->stream = NULL;
#line 49 "../gpx-viewer/libgpx/gpx-parser-json.vala"
	result = 0;
#line 49 "../gpx-viewer/libgpx/gpx-parser-json.vala"
	return result;
#line 151 "gpx-parser-json.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 54 "../gpx-viewer/libgpx/gpx-parser-json.vala"
	return self ? g_object_ref (self) : NULL;
#line 159 "gpx-parser-json.c"
}

GpxJsonFile*
gpx_json_file_construct (GType object_type,
                         GFile* file)
{
	GpxJsonFile * self = NULL;
	GFile* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 52 "../gpx-viewer/libgpx/gpx-parser-json.vala"
	self = (GpxJsonFile*) gpx_file_base_construct (object_type);
#line 54 "../gpx-viewer/libgpx/gpx-parser-json.vala"
	_tmp0_ = _g_object_ref0 (file);
#line 54 "../gpx-viewer/libgpx/gpx-parser-json.vala"
	_g_object_unref0 (((GpxFileBase*) self)->file);
#line 54 "../gpx-viewer/libgpx/gpx-parser-json.vala"
	((GpxFileBase*) self)->file = _tmp0_;
#line 177 "gpx-parser-json.c"
	{
		GFileInputStream* _tmp1_ = NULL;
		GFileInputStream* _tmp2_;
		GFileInputStream* _tmp3_;
		GDataInputStream* dstream = NULL;
		GFileInputStream* _tmp4_;
		GDataInputStream* _tmp5_;
		GpxTrack* track = NULL;
		GpxTrack* _tmp6_;
		gchar* line = NULL;
		GpxTrack* _tmp45_;
		GpxTrack* _tmp46_;
		GpxTrack* _tmp47_;
#line 57 "../gpx-viewer/libgpx/gpx-parser-json.vala"
		_tmp2_ = g_file_read (file, NULL, &_inner_error0_);
#line 57 "../gpx-viewer/libgpx/gpx-parser-json.vala"
		_tmp1_ = _tmp2_;
#line 57 "../gpx-viewer/libgpx/gpx-parser-json.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 197 "gpx-parser-json.c"
			goto __catch0_g_error;
		}
#line 57 "../gpx-viewer/libgpx/gpx-parser-json.vala"
		_tmp3_ = _tmp1_;
#line 57 "../gpx-viewer/libgpx/gpx-parser-json.vala"
		_tmp1_ = NULL;
#line 57 "../gpx-viewer/libgpx/gpx-parser-json.vala"
		_g_object_unref0 (self->priv->stream);
#line 57 "../gpx-viewer/libgpx/gpx-parser-json.vala"
		self->priv->stream = _tmp3_;
#line 58 "../gpx-viewer/libgpx/gpx-parser-json.vala"
		_tmp4_ = self->priv->stream;
#line 58 "../gpx-viewer/libgpx/gpx-parser-json.vala"
		_tmp5_ = g_data_input_stream_new ((GInputStream*) _tmp4_);
#line 58 "../gpx-viewer/libgpx/gpx-parser-json.vala"
		dstream = _tmp5_;
#line 59 "../gpx-viewer/libgpx/gpx-parser-json.vala"
		_tmp6_ = gpx_track_new ();
#line 59 "../gpx-viewer/libgpx/gpx-parser-json.vala"
		track = _tmp6_;
#line 61 "../gpx-viewer/libgpx/gpx-parser-json.vala"
		while (TRUE) {
#line 220 "gpx-parser-json.c"
			gchar* _tmp7_ = NULL;
			GDataInputStream* _tmp8_;
			gchar* _tmp9_;
			gchar* _tmp10_;
			const gchar* _tmp11_;
			const gchar* _tmp12_;
			JsonParser* parser = NULL;
			JsonParser* _tmp13_;
			JsonParser* _tmp14_;
			const gchar* _tmp15_;
			GpxPoint* p = NULL;
			GpxPoint* _tmp16_;
			gdouble flat = 0.0;
			JsonParser* _tmp17_;
			JsonNode* _tmp18_;
			JsonObject* _tmp19_;
			gdouble flon = 0.0;
			JsonParser* _tmp20_;
			JsonNode* _tmp21_;
			JsonObject* _tmp22_;
			GDateTime* time = NULL;
			JsonParser* _tmp23_;
			JsonNode* _tmp24_;
			JsonObject* _tmp25_;
			JsonParser* _tmp26_;
			JsonNode* _tmp27_;
			JsonObject* _tmp28_;
			JsonParser* _tmp29_;
			JsonNode* _tmp30_;
			JsonObject* _tmp31_;
			JsonParser* _tmp32_;
			JsonNode* _tmp33_;
			JsonObject* _tmp34_;
			JsonParser* _tmp35_;
			JsonNode* _tmp36_;
			JsonObject* _tmp37_;
			GDateTime* _tmp38_;
			GDateTime* _tmp39_;
			GpxPoint* _tmp40_;
			GDateTime* _tmp41_;
			GpxPoint* _tmp42_;
			GpxTrack* _tmp43_;
			GpxPoint* _tmp44_;
#line 61 "../gpx-viewer/libgpx/gpx-parser-json.vala"
			_tmp8_ = dstream;
#line 61 "../gpx-viewer/libgpx/gpx-parser-json.vala"
			_tmp9_ = g_data_input_stream_read_line (_tmp8_, NULL, NULL, &_inner_error0_);
#line 61 "../gpx-viewer/libgpx/gpx-parser-json.vala"
			_tmp7_ = _tmp9_;
#line 61 "../gpx-viewer/libgpx/gpx-parser-json.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 61 "../gpx-viewer/libgpx/gpx-parser-json.vala"
				_g_free0 (line);
#line 61 "../gpx-viewer/libgpx/gpx-parser-json.vala"
				_g_object_unref0 (track);
#line 61 "../gpx-viewer/libgpx/gpx-parser-json.vala"
				_g_object_unref0 (dstream);
#line 61 "../gpx-viewer/libgpx/gpx-parser-json.vala"
				_g_object_unref0 (_tmp1_);
#line 280 "gpx-parser-json.c"
				goto __catch0_g_error;
			}
#line 61 "../gpx-viewer/libgpx/gpx-parser-json.vala"
			_tmp10_ = _tmp7_;
#line 61 "../gpx-viewer/libgpx/gpx-parser-json.vala"
			_tmp7_ = NULL;
#line 61 "../gpx-viewer/libgpx/gpx-parser-json.vala"
			_g_free0 (line);
#line 61 "../gpx-viewer/libgpx/gpx-parser-json.vala"
			line = _tmp10_;
#line 61 "../gpx-viewer/libgpx/gpx-parser-json.vala"
			_tmp11_ = line;
#line 61 "../gpx-viewer/libgpx/gpx-parser-json.vala"
			if (!(_tmp11_ != NULL)) {
#line 61 "../gpx-viewer/libgpx/gpx-parser-json.vala"
				_g_free0 (_tmp7_);
#line 61 "../gpx-viewer/libgpx/gpx-parser-json.vala"
				break;
#line 299 "gpx-parser-json.c"
			}
#line 64 "../gpx-viewer/libgpx/gpx-parser-json.vala"
			_tmp12_ = line;
#line 64 "../gpx-viewer/libgpx/gpx-parser-json.vala"
			g_debug ("gpx-parser-json.vala:64: %s", _tmp12_);
#line 65 "../gpx-viewer/libgpx/gpx-parser-json.vala"
			_tmp13_ = json_parser_new ();
#line 65 "../gpx-viewer/libgpx/gpx-parser-json.vala"
			parser = _tmp13_;
#line 66 "../gpx-viewer/libgpx/gpx-parser-json.vala"
			_tmp14_ = parser;
#line 66 "../gpx-viewer/libgpx/gpx-parser-json.vala"
			_tmp15_ = line;
#line 66 "../gpx-viewer/libgpx/gpx-parser-json.vala"
			json_parser_load_from_data (_tmp14_, (const gchar*) _tmp15_, (gssize) -1, &_inner_error0_);
#line 66 "../gpx-viewer/libgpx/gpx-parser-json.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 66 "../gpx-viewer/libgpx/gpx-parser-json.vala"
				_g_object_unref0 (parser);
#line 66 "../gpx-viewer/libgpx/gpx-parser-json.vala"
				_g_free0 (_tmp7_);
#line 66 "../gpx-viewer/libgpx/gpx-parser-json.vala"
				_g_free0 (line);
#line 66 "../gpx-viewer/libgpx/gpx-parser-json.vala"
				_g_object_unref0 (track);
#line 66 "../gpx-viewer/libgpx/gpx-parser-json.vala"
				_g_object_unref0 (dstream);
#line 66 "../gpx-viewer/libgpx/gpx-parser-json.vala"
				_g_object_unref0 (_tmp1_);
#line 329 "gpx-parser-json.c"
				goto __catch0_g_error;
			}
#line 68 "../gpx-viewer/libgpx/gpx-parser-json.vala"
			_tmp16_ = gpx_point_new ();
#line 68 "../gpx-viewer/libgpx/gpx-parser-json.vala"
			p = _tmp16_;
#line 69 "../gpx-viewer/libgpx/gpx-parser-json.vala"
			_tmp17_ = parser;
#line 69 "../gpx-viewer/libgpx/gpx-parser-json.vala"
			_tmp18_ = json_parser_get_root (_tmp17_);
#line 69 "../gpx-viewer/libgpx/gpx-parser-json.vala"
			_tmp19_ = json_node_get_object (_tmp18_);
#line 69 "../gpx-viewer/libgpx/gpx-parser-json.vala"
			flat = json_object_get_double_member (_tmp19_, "latitude");
#line 70 "../gpx-viewer/libgpx/gpx-parser-json.vala"
			_tmp20_ = parser;
#line 70 "../gpx-viewer/libgpx/gpx-parser-json.vala"
			_tmp21_ = json_parser_get_root (_tmp20_);
#line 70 "../gpx-viewer/libgpx/gpx-parser-json.vala"
			_tmp22_ = json_node_get_object (_tmp21_);
#line 70 "../gpx-viewer/libgpx/gpx-parser-json.vala"
			flon = json_object_get_double_member (_tmp22_, "longitude");
#line 72 "../gpx-viewer/libgpx/gpx-parser-json.vala"
			_tmp23_ = parser;
#line 72 "../gpx-viewer/libgpx/gpx-parser-json.vala"
			_tmp24_ = json_parser_get_root (_tmp23_);
#line 72 "../gpx-viewer/libgpx/gpx-parser-json.vala"
			_tmp25_ = json_node_get_object (_tmp24_);
#line 72 "../gpx-viewer/libgpx/gpx-parser-json.vala"
			_tmp26_ = parser;
#line 72 "../gpx-viewer/libgpx/gpx-parser-json.vala"
			_tmp27_ = json_parser_get_root (_tmp26_);
#line 72 "../gpx-viewer/libgpx/gpx-parser-json.vala"
			_tmp28_ = json_node_get_object (_tmp27_);
#line 72 "../gpx-viewer/libgpx/gpx-parser-json.vala"
			_tmp29_ = parser;
#line 72 "../gpx-viewer/libgpx/gpx-parser-json.vala"
			_tmp30_ = json_parser_get_root (_tmp29_);
#line 72 "../gpx-viewer/libgpx/gpx-parser-json.vala"
			_tmp31_ = json_node_get_object (_tmp30_);
#line 72 "../gpx-viewer/libgpx/gpx-parser-json.vala"
			_tmp32_ = parser;
#line 72 "../gpx-viewer/libgpx/gpx-parser-json.vala"
			_tmp33_ = json_parser_get_root (_tmp32_);
#line 72 "../gpx-viewer/libgpx/gpx-parser-json.vala"
			_tmp34_ = json_node_get_object (_tmp33_);
#line 72 "../gpx-viewer/libgpx/gpx-parser-json.vala"
			_tmp35_ = parser;
#line 72 "../gpx-viewer/libgpx/gpx-parser-json.vala"
			_tmp36_ = json_parser_get_root (_tmp35_);
#line 72 "../gpx-viewer/libgpx/gpx-parser-json.vala"
			_tmp37_ = json_node_get_object (_tmp36_);
#line 72 "../gpx-viewer/libgpx/gpx-parser-json.vala"
			_tmp38_ = g_date_time_new_utc ((gint) json_object_get_int_member (_tmp25_, "year"), (gint) json_object_get_int_member (_tmp28_, "month"), (gint) json_object_get_int_member (_tmp31_, "day"), (gint) json_object_get_int_member (_tmp34_, "hour"), (gint) json_object_get_int_member (_tmp37_, "minute"), (gdouble) 0);
#line 72 "../gpx-viewer/libgpx/gpx-parser-json.vala"
			time = _tmp38_;
#line 79 "../gpx-viewer/libgpx/gpx-parser-json.vala"
			_tmp39_ = time;
#line 79 "../gpx-viewer/libgpx/gpx-parser-json.vala"
			g_print ("%lld\r\n", g_date_time_to_unix (_tmp39_));
#line 80 "../gpx-viewer/libgpx/gpx-parser-json.vala"
			_tmp40_ = p;
#line 80 "../gpx-viewer/libgpx/gpx-parser-json.vala"
			_tmp41_ = time;
#line 80 "../gpx-viewer/libgpx/gpx-parser-json.vala"
			gpx_point_set_utime (_tmp40_, (time_t) ((gint32) g_date_time_to_unix (_tmp41_)));
#line 81 "../gpx-viewer/libgpx/gpx-parser-json.vala"
			_tmp42_ = p;
#line 81 "../gpx-viewer/libgpx/gpx-parser-json.vala"
			gpx_point_set_position (_tmp42_, flat, flon);
#line 82 "../gpx-viewer/libgpx/gpx-parser-json.vala"
			_tmp43_ = track;
#line 82 "../gpx-viewer/libgpx/gpx-parser-json.vala"
			_tmp44_ = p;
#line 82 "../gpx-viewer/libgpx/gpx-parser-json.vala"
			gpx_track_add_point (_tmp43_, _tmp44_);
#line 61 "../gpx-viewer/libgpx/gpx-parser-json.vala"
			_g_date_time_unref0 (time);
#line 61 "../gpx-viewer/libgpx/gpx-parser-json.vala"
			_gpx_point_unref0 (p);
#line 61 "../gpx-viewer/libgpx/gpx-parser-json.vala"
			_g_object_unref0 (parser);
#line 61 "../gpx-viewer/libgpx/gpx-parser-json.vala"
			_g_free0 (_tmp7_);
#line 414 "gpx-parser-json.c"
		}
#line 85 "../gpx-viewer/libgpx/gpx-parser-json.vala"
		_tmp45_ = track;
#line 85 "../gpx-viewer/libgpx/gpx-parser-json.vala"
		gpx_track_filter_points (_tmp45_);
#line 86 "../gpx-viewer/libgpx/gpx-parser-json.vala"
		_tmp46_ = track;
#line 86 "../gpx-viewer/libgpx/gpx-parser-json.vala"
		_tmp47_ = _g_object_ref0 (_tmp46_);
#line 86 "../gpx-viewer/libgpx/gpx-parser-json.vala"
		((GpxFileBase*) self)->tracks = g_list_append (((GpxFileBase*) self)->tracks, _tmp47_);
#line 55 "../gpx-viewer/libgpx/gpx-parser-json.vala"
		_g_free0 (line);
#line 55 "../gpx-viewer/libgpx/gpx-parser-json.vala"
		_g_object_unref0 (track);
#line 55 "../gpx-viewer/libgpx/gpx-parser-json.vala"
		_g_object_unref0 (dstream);
#line 55 "../gpx-viewer/libgpx/gpx-parser-json.vala"
		_g_object_unref0 (_tmp1_);
#line 434 "gpx-parser-json.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GFile* _tmp48_;
		gchar* _tmp49_;
		gchar* _tmp50_;
		GError* _tmp51_;
		const gchar* _tmp52_;
#line 55 "../gpx-viewer/libgpx/gpx-parser-json.vala"
		e = _inner_error0_;
#line 55 "../gpx-viewer/libgpx/gpx-parser-json.vala"
		_inner_error0_ = NULL;
#line 90 "../gpx-viewer/libgpx/gpx-parser-json.vala"
		_tmp48_ = ((GpxFileBase*) self)->file;
#line 90 "../gpx-viewer/libgpx/gpx-parser-json.vala"
		_tmp49_ = g_file_get_uri (_tmp48_);
#line 90 "../gpx-viewer/libgpx/gpx-parser-json.vala"
		_tmp50_ = _tmp49_;
#line 90 "../gpx-viewer/libgpx/gpx-parser-json.vala"
		_tmp51_ = e;
#line 90 "../gpx-viewer/libgpx/gpx-parser-json.vala"
		_tmp52_ = _tmp51_->message;
#line 90 "../gpx-viewer/libgpx/gpx-parser-json.vala"
		g_critical ("gpx-parser-json.vala:90: failed to open file: '%s' error: %s", _tmp50_, _tmp52_);
#line 90 "../gpx-viewer/libgpx/gpx-parser-json.vala"
		_g_free0 (_tmp50_);
#line 55 "../gpx-viewer/libgpx/gpx-parser-json.vala"
		_g_error_free0 (e);
#line 465 "gpx-parser-json.c"
	}
	__finally0:
#line 55 "../gpx-viewer/libgpx/gpx-parser-json.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 55 "../gpx-viewer/libgpx/gpx-parser-json.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 55 "../gpx-viewer/libgpx/gpx-parser-json.vala"
		g_clear_error (&_inner_error0_);
#line 55 "../gpx-viewer/libgpx/gpx-parser-json.vala"
		return NULL;
#line 476 "gpx-parser-json.c"
	}
#line 52 "../gpx-viewer/libgpx/gpx-parser-json.vala"
	return self;
#line 480 "gpx-parser-json.c"
}

GpxJsonFile*
gpx_json_file_new (GFile* file)
{
#line 52 "../gpx-viewer/libgpx/gpx-parser-json.vala"
	return gpx_json_file_construct (GPX_TYPE_JSON_FILE, file);
#line 488 "gpx-parser-json.c"
}

static void
gpx_json_file_class_init (GpxJsonFileClass * klass,
                          gpointer klass_data)
{
#line 22 "../gpx-viewer/libgpx/gpx-parser-json.vala"
	gpx_json_file_parent_class = g_type_class_peek_parent (klass);
#line 22 "../gpx-viewer/libgpx/gpx-parser-json.vala"
	g_type_class_adjust_private_offset (klass, &GpxJsonFile_private_offset);
#line 22 "../gpx-viewer/libgpx/gpx-parser-json.vala"
	G_OBJECT_CLASS (klass)->finalize = gpx_json_file_finalize;
#line 501 "gpx-parser-json.c"
}

static void
gpx_json_file_instance_init (GpxJsonFile * self,
                             gpointer klass)
{
#line 22 "../gpx-viewer/libgpx/gpx-parser-json.vala"
	self->priv = gpx_json_file_get_instance_private (self);
#line 31 "../gpx-viewer/libgpx/gpx-parser-json.vala"
	self->priv->stream = NULL;
#line 512 "gpx-parser-json.c"
}

static void
gpx_json_file_finalize (GObject * obj)
{
	GpxJsonFile * self;
#line 22 "../gpx-viewer/libgpx/gpx-parser-json.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GPX_TYPE_JSON_FILE, GpxJsonFile);
#line 31 "../gpx-viewer/libgpx/gpx-parser-json.vala"
	_g_object_unref0 (self->priv->stream);
#line 22 "../gpx-viewer/libgpx/gpx-parser-json.vala"
	G_OBJECT_CLASS (gpx_json_file_parent_class)->finalize (obj);
#line 525 "gpx-parser-json.c"
}

static GType
gpx_json_file_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GpxJsonFileClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gpx_json_file_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GpxJsonFile), 0, (GInstanceInitFunc) gpx_json_file_instance_init, NULL };
	GType gpx_json_file_type_id;
	gpx_json_file_type_id = g_type_register_static (GPX_TYPE_FILE_BASE, "GpxJsonFile", &g_define_type_info, 0);
	GpxJsonFile_private_offset = g_type_add_instance_private (gpx_json_file_type_id, sizeof (GpxJsonFilePrivate));
	return gpx_json_file_type_id;
}

GType
gpx_json_file_get_type (void)
{
	static volatile gsize gpx_json_file_type_id__once = 0;
	if (g_once_init_enter (&gpx_json_file_type_id__once)) {
		GType gpx_json_file_type_id;
		gpx_json_file_type_id = gpx_json_file_get_type_once ();
		g_once_init_leave (&gpx_json_file_type_id__once, gpx_json_file_type_id);
	}
	return gpx_json_file_type_id__once;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

