/* gpx-playback.c generated by valac 0.56.17, the Vala compiler
 * generated from gpx-playback.vala, do not modify */

/* Gpx Viewer
 * Copyright (C) 2009-2015 Qball Cow <qball@sarine.nl>
 * Project homepage: http://blog.sarine.nl/

 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include "gpx.h"
#include <glib-object.h>
#include <float.h>
#include <math.h>

#define GPX_GT_LOG_DOMAIN "GPX_PLAYBACK"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	GPX_PLAYBACK_0_PROPERTY,
	GPX_PLAYBACK_SPEEDUP_PROPERTY,
	GPX_PLAYBACK_NUM_PROPERTIES
};
static GParamSpec* gpx_playback_properties[GPX_PLAYBACK_NUM_PROPERTIES];
#define _g_timer_destroy0(var) ((var == NULL) ? NULL : (var = (g_timer_destroy (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _gpx_point_unref0(var) ((var == NULL) ? NULL : (var = (gpx_point_unref (var), NULL)))
enum  {
	GPX_PLAYBACK_TICK_SIGNAL,
	GPX_PLAYBACK_STATE_CHANGED_SIGNAL,
	GPX_PLAYBACK_NUM_SIGNALS
};
static guint gpx_playback_signals[GPX_PLAYBACK_NUM_SIGNALS] = {0};

struct _GpxPlaybackPrivate {
	GTimer* progress;
	GpxTrack* track;
	guint timer;
	GList* current;
	GpxPoint* first;
	gint _speedup;
};

static gint GpxPlayback_private_offset;
static gpointer gpx_playback_parent_class = NULL;

static gboolean _gpx_playback_timer_callback_gsource_func (gpointer self);
static void g_cclosure_user_marshal_VOID__GPX_POINT (GClosure * closure,
                                              GValue * return_value,
                                              guint n_param_values,
                                              const GValue * param_values,
                                              gpointer invocation_hint,
                                              gpointer marshal_data);
static void gpx_playback_finalize (GObject * obj);
static GType gpx_playback_get_type_once (void);
static void _vala_gpx_playback_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec);
static void _vala_gpx_playback_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
gpx_playback_get_instance_private (GpxPlayback* self)
{
	return G_STRUCT_MEMBER_P (self, GpxPlayback_private_offset);
}

static GType
gpx_playback_state_get_type_once (void)
{
	static const GEnumValue values[] = {{GPX_PLAYBACK_STATE_STOPPED, "GPX_PLAYBACK_STATE_STOPPED", "stopped"}, {GPX_PLAYBACK_STATE_PAUSED, "GPX_PLAYBACK_STATE_PAUSED", "paused"}, {GPX_PLAYBACK_STATE_PLAY, "GPX_PLAYBACK_STATE_PLAY", "play"}, {0, NULL, NULL}};
	GType gpx_playback_state_type_id;
	gpx_playback_state_type_id = g_enum_register_static ("GpxPlaybackState", values);
	return gpx_playback_state_type_id;
}

GType
gpx_playback_state_get_type (void)
{
	static volatile gsize gpx_playback_state_type_id__once = 0;
	if (g_once_init_enter (&gpx_playback_state_type_id__once)) {
		GType gpx_playback_state_type_id;
		gpx_playback_state_type_id = gpx_playback_state_get_type_once ();
		g_once_init_leave (&gpx_playback_state_type_id__once, gpx_playback_state_type_id);
	}
	return gpx_playback_state_type_id__once;
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 55 "../gpx-viewer/libgpx/gpx-playback.vala"
	return self ? g_object_ref (self) : NULL;
#line 122 "gpx-playback.c"
}

static gpointer
_gpx_point_ref0 (gpointer self)
{
#line 58 "../gpx-viewer/libgpx/gpx-playback.vala"
	return self ? gpx_point_ref (self) : NULL;
#line 130 "gpx-playback.c"
}

void
gpx_playback_set_track (GpxPlayback* self,
                        GpxTrack* track)
{
	GpxTrack* _tmp0_;
	gboolean _tmp1_ = FALSE;
	GpxTrack* _tmp2_;
#line 54 "../gpx-viewer/libgpx/gpx-playback.vala"
	gpx_playback_stop (self);
#line 55 "../gpx-viewer/libgpx/gpx-playback.vala"
	_tmp0_ = _g_object_ref0 (track);
#line 55 "../gpx-viewer/libgpx/gpx-playback.vala"
	_g_object_unref0 (self->priv->track);
#line 55 "../gpx-viewer/libgpx/gpx-playback.vala"
	self->priv->track = _tmp0_;
#line 56 "../gpx-viewer/libgpx/gpx-playback.vala"
	_tmp2_ = self->priv->track;
#line 56 "../gpx-viewer/libgpx/gpx-playback.vala"
	if (_tmp2_ != NULL) {
#line 152 "gpx-playback.c"
		GpxTrack* _tmp3_;
		GList* _tmp4_;
#line 56 "../gpx-viewer/libgpx/gpx-playback.vala"
		_tmp3_ = self->priv->track;
#line 56 "../gpx-viewer/libgpx/gpx-playback.vala"
		_tmp4_ = _tmp3_->points;
#line 56 "../gpx-viewer/libgpx/gpx-playback.vala"
		_tmp1_ = _tmp4_ != NULL;
#line 161 "gpx-playback.c"
	} else {
#line 56 "../gpx-viewer/libgpx/gpx-playback.vala"
		_tmp1_ = FALSE;
#line 165 "gpx-playback.c"
	}
#line 56 "../gpx-viewer/libgpx/gpx-playback.vala"
	if (_tmp1_) {
#line 169 "gpx-playback.c"
		GpxTrack* _tmp5_;
		GList* _tmp6_;
		GList* _tmp7_;
		gconstpointer _tmp8_;
		GpxPoint* _tmp9_;
#line 58 "../gpx-viewer/libgpx/gpx-playback.vala"
		_tmp5_ = self->priv->track;
#line 58 "../gpx-viewer/libgpx/gpx-playback.vala"
		_tmp6_ = _tmp5_->points;
#line 58 "../gpx-viewer/libgpx/gpx-playback.vala"
		_tmp7_ = g_list_first (_tmp6_);
#line 58 "../gpx-viewer/libgpx/gpx-playback.vala"
		_tmp8_ = _tmp7_->data;
#line 58 "../gpx-viewer/libgpx/gpx-playback.vala"
		_tmp9_ = _gpx_point_ref0 ((GpxPoint*) _tmp8_);
#line 58 "../gpx-viewer/libgpx/gpx-playback.vala"
		_gpx_point_unref0 (self->priv->first);
#line 58 "../gpx-viewer/libgpx/gpx-playback.vala"
		self->priv->first = _tmp9_;
#line 189 "gpx-playback.c"
	}
}

GpxPlayback*
gpx_playback_construct (GType object_type,
                        GpxTrack* track)
{
	GpxPlayback * self = NULL;
	GpxTrack* _tmp0_;
	gboolean _tmp1_ = FALSE;
	GpxTrack* _tmp2_;
#line 61 "../gpx-viewer/libgpx/gpx-playback.vala"
	self = (GpxPlayback*) g_object_new (object_type, NULL);
#line 63 "../gpx-viewer/libgpx/gpx-playback.vala"
	_tmp0_ = _g_object_ref0 (track);
#line 63 "../gpx-viewer/libgpx/gpx-playback.vala"
	_g_object_unref0 (self->priv->track);
#line 63 "../gpx-viewer/libgpx/gpx-playback.vala"
	self->priv->track = _tmp0_;
#line 64 "../gpx-viewer/libgpx/gpx-playback.vala"
	_tmp2_ = self->priv->track;
#line 64 "../gpx-viewer/libgpx/gpx-playback.vala"
	if (_tmp2_ != NULL) {
#line 213 "gpx-playback.c"
		GpxTrack* _tmp3_;
		GList* _tmp4_;
#line 64 "../gpx-viewer/libgpx/gpx-playback.vala"
		_tmp3_ = self->priv->track;
#line 64 "../gpx-viewer/libgpx/gpx-playback.vala"
		_tmp4_ = _tmp3_->points;
#line 64 "../gpx-viewer/libgpx/gpx-playback.vala"
		_tmp1_ = _tmp4_ != NULL;
#line 222 "gpx-playback.c"
	} else {
#line 64 "../gpx-viewer/libgpx/gpx-playback.vala"
		_tmp1_ = FALSE;
#line 226 "gpx-playback.c"
	}
#line 64 "../gpx-viewer/libgpx/gpx-playback.vala"
	if (_tmp1_) {
#line 230 "gpx-playback.c"
		GpxTrack* _tmp5_;
		GList* _tmp6_;
		GList* _tmp7_;
		gconstpointer _tmp8_;
		GpxPoint* _tmp9_;
#line 66 "../gpx-viewer/libgpx/gpx-playback.vala"
		_tmp5_ = self->priv->track;
#line 66 "../gpx-viewer/libgpx/gpx-playback.vala"
		_tmp6_ = _tmp5_->points;
#line 66 "../gpx-viewer/libgpx/gpx-playback.vala"
		_tmp7_ = g_list_first (_tmp6_);
#line 66 "../gpx-viewer/libgpx/gpx-playback.vala"
		_tmp8_ = _tmp7_->data;
#line 66 "../gpx-viewer/libgpx/gpx-playback.vala"
		_tmp9_ = _gpx_point_ref0 ((GpxPoint*) _tmp8_);
#line 66 "../gpx-viewer/libgpx/gpx-playback.vala"
		_gpx_point_unref0 (self->priv->first);
#line 66 "../gpx-viewer/libgpx/gpx-playback.vala"
		self->priv->first = _tmp9_;
#line 250 "gpx-playback.c"
	}
#line 61 "../gpx-viewer/libgpx/gpx-playback.vala"
	return self;
#line 254 "gpx-playback.c"
}

GpxPlayback*
gpx_playback_new (GpxTrack* track)
{
#line 61 "../gpx-viewer/libgpx/gpx-playback.vala"
	return gpx_playback_construct (GPX_TYPE_PLAYBACK, track);
#line 262 "gpx-playback.c"
}

gboolean
gpx_playback_timer_callback (GpxPlayback* self)
{
	GList* _tmp0_;
	GList* _tmp3_;
	gconstpointer _tmp4_;
	GpxPoint* _tmp5_;
	GTimer* _tmp6_;
	GList* _tmp7_;
	gconstpointer _tmp8_;
	gboolean result;
#line 71 "../gpx-viewer/libgpx/gpx-playback.vala"
	_tmp0_ = self->priv->current;
#line 71 "../gpx-viewer/libgpx/gpx-playback.vala"
	if (_tmp0_ == NULL) {
#line 280 "gpx-playback.c"
		GTimer* _tmp1_;
		GTimer* _tmp2_;
#line 72 "../gpx-viewer/libgpx/gpx-playback.vala"
		_tmp1_ = self->priv->progress;
#line 72 "../gpx-viewer/libgpx/gpx-playback.vala"
		g_timer_stop (_tmp1_);
#line 73 "../gpx-viewer/libgpx/gpx-playback.vala"
		_tmp2_ = self->priv->progress;
#line 73 "../gpx-viewer/libgpx/gpx-playback.vala"
		g_timer_reset (_tmp2_);
#line 74 "../gpx-viewer/libgpx/gpx-playback.vala"
		g_signal_emit (self, gpx_playback_signals[GPX_PLAYBACK_STATE_CHANGED_SIGNAL], 0, GPX_PLAYBACK_STATE_STOPPED);
#line 75 "../gpx-viewer/libgpx/gpx-playback.vala"
		g_signal_emit (self, gpx_playback_signals[GPX_PLAYBACK_TICK_SIGNAL], 0, NULL);
#line 76 "../gpx-viewer/libgpx/gpx-playback.vala"
		result = FALSE;
#line 76 "../gpx-viewer/libgpx/gpx-playback.vala"
		return result;
#line 299 "gpx-playback.c"
	}
#line 79 "../gpx-viewer/libgpx/gpx-playback.vala"
	_tmp3_ = self->priv->current;
#line 79 "../gpx-viewer/libgpx/gpx-playback.vala"
	_tmp4_ = _tmp3_->data;
#line 79 "../gpx-viewer/libgpx/gpx-playback.vala"
	_tmp5_ = self->priv->first;
#line 79 "../gpx-viewer/libgpx/gpx-playback.vala"
	_tmp6_ = self->priv->progress;
#line 79 "../gpx-viewer/libgpx/gpx-playback.vala"
	if (((gdouble) gpx_point_get_time ((GpxPoint*) _tmp4_)) > (gpx_point_get_time (_tmp5_) + (self->priv->_speedup * g_timer_elapsed (_tmp6_, NULL)))) {
#line 79 "../gpx-viewer/libgpx/gpx-playback.vala"
		result = TRUE;
#line 79 "../gpx-viewer/libgpx/gpx-playback.vala"
		return result;
#line 315 "gpx-playback.c"
	}
#line 80 "../gpx-viewer/libgpx/gpx-playback.vala"
	_tmp7_ = self->priv->current;
#line 80 "../gpx-viewer/libgpx/gpx-playback.vala"
	_tmp8_ = _tmp7_->data;
#line 80 "../gpx-viewer/libgpx/gpx-playback.vala"
	g_signal_emit (self, gpx_playback_signals[GPX_PLAYBACK_TICK_SIGNAL], 0, (GpxPoint*) _tmp8_);
#line 82 "../gpx-viewer/libgpx/gpx-playback.vala"
	while (TRUE) {
#line 325 "gpx-playback.c"
		gboolean _tmp9_ = FALSE;
		GList* _tmp10_;
		GList* _tmp15_;
		GList* _tmp16_;
#line 82 "../gpx-viewer/libgpx/gpx-playback.vala"
		_tmp10_ = self->priv->current;
#line 82 "../gpx-viewer/libgpx/gpx-playback.vala"
		if (_tmp10_ != NULL) {
#line 334 "gpx-playback.c"
			GList* _tmp11_;
			gconstpointer _tmp12_;
			GpxPoint* _tmp13_;
			GTimer* _tmp14_;
#line 82 "../gpx-viewer/libgpx/gpx-playback.vala"
			_tmp11_ = self->priv->current;
#line 82 "../gpx-viewer/libgpx/gpx-playback.vala"
			_tmp12_ = _tmp11_->data;
#line 82 "../gpx-viewer/libgpx/gpx-playback.vala"
			_tmp13_ = self->priv->first;
#line 82 "../gpx-viewer/libgpx/gpx-playback.vala"
			_tmp14_ = self->priv->progress;
#line 82 "../gpx-viewer/libgpx/gpx-playback.vala"
			_tmp9_ = ((gdouble) gpx_point_get_time ((GpxPoint*) _tmp12_)) < (gpx_point_get_time (_tmp13_) + (self->priv->_speedup * g_timer_elapsed (_tmp14_, NULL)));
#line 349 "gpx-playback.c"
		} else {
#line 82 "../gpx-viewer/libgpx/gpx-playback.vala"
			_tmp9_ = FALSE;
#line 353 "gpx-playback.c"
		}
#line 82 "../gpx-viewer/libgpx/gpx-playback.vala"
		if (!_tmp9_) {
#line 82 "../gpx-viewer/libgpx/gpx-playback.vala"
			break;
#line 359 "gpx-playback.c"
		}
#line 82 "../gpx-viewer/libgpx/gpx-playback.vala"
		_tmp15_ = self->priv->current;
#line 82 "../gpx-viewer/libgpx/gpx-playback.vala"
		_tmp16_ = _tmp15_->next;
#line 82 "../gpx-viewer/libgpx/gpx-playback.vala"
		self->priv->current = _tmp16_;
#line 367 "gpx-playback.c"
	}
#line 84 "../gpx-viewer/libgpx/gpx-playback.vala"
	result = TRUE;
#line 84 "../gpx-viewer/libgpx/gpx-playback.vala"
	return result;
#line 373 "gpx-playback.c"
}

static gboolean
_gpx_playback_timer_callback_gsource_func (gpointer self)
{
	gboolean result;
	result = gpx_playback_timer_callback ((GpxPlayback*) self);
#line 95 "../gpx-viewer/libgpx/gpx-playback.vala"
	return result;
#line 383 "gpx-playback.c"
}

void
gpx_playback_start (GpxPlayback* self)
{
	GpxPoint* _tmp0_;
#line 88 "../gpx-viewer/libgpx/gpx-playback.vala"
	gpx_playback_stop (self);
#line 89 "../gpx-viewer/libgpx/gpx-playback.vala"
	_tmp0_ = self->priv->first;
#line 89 "../gpx-viewer/libgpx/gpx-playback.vala"
	if (_tmp0_ != NULL) {
#line 396 "gpx-playback.c"
		GTimer* _tmp1_;
		GpxTrack* _tmp2_;
		GList* _tmp3_;
		GList* _tmp4_;
#line 91 "../gpx-viewer/libgpx/gpx-playback.vala"
		_tmp1_ = self->priv->progress;
#line 91 "../gpx-viewer/libgpx/gpx-playback.vala"
		g_timer_start (_tmp1_);
#line 92 "../gpx-viewer/libgpx/gpx-playback.vala"
		g_signal_emit (self, gpx_playback_signals[GPX_PLAYBACK_STATE_CHANGED_SIGNAL], 0, GPX_PLAYBACK_STATE_PLAY);
#line 93 "../gpx-viewer/libgpx/gpx-playback.vala"
		g_debug ("gpx-playback.vala:93: start playback\n");
#line 94 "../gpx-viewer/libgpx/gpx-playback.vala"
		_tmp2_ = self->priv->track;
#line 94 "../gpx-viewer/libgpx/gpx-playback.vala"
		_tmp3_ = _tmp2_->points;
#line 94 "../gpx-viewer/libgpx/gpx-playback.vala"
		_tmp4_ = g_list_first (_tmp3_);
#line 94 "../gpx-viewer/libgpx/gpx-playback.vala"
		self->priv->current = _tmp4_;
#line 95 "../gpx-viewer/libgpx/gpx-playback.vala"
		self->priv->timer = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 100, _gpx_playback_timer_callback_gsource_func, g_object_ref (self), g_object_unref);
#line 419 "gpx-playback.c"
	}
}

void
gpx_playback_pause (GpxPlayback* self)
{
	GList* _tmp0_;
#line 100 "../gpx-viewer/libgpx/gpx-playback.vala"
	_tmp0_ = self->priv->current;
#line 100 "../gpx-viewer/libgpx/gpx-playback.vala"
	if (_tmp0_ == NULL) {
#line 100 "../gpx-viewer/libgpx/gpx-playback.vala"
		return;
#line 433 "gpx-playback.c"
	}
#line 101 "../gpx-viewer/libgpx/gpx-playback.vala"
	if (self->priv->timer > ((guint) 0)) {
#line 437 "gpx-playback.c"
		GTimer* _tmp1_;
#line 102 "../gpx-viewer/libgpx/gpx-playback.vala"
		g_source_remove (self->priv->timer);
#line 103 "../gpx-viewer/libgpx/gpx-playback.vala"
		self->priv->timer = (guint) 0;
#line 104 "../gpx-viewer/libgpx/gpx-playback.vala"
		_tmp1_ = self->priv->progress;
#line 104 "../gpx-viewer/libgpx/gpx-playback.vala"
		g_timer_stop (_tmp1_);
#line 105 "../gpx-viewer/libgpx/gpx-playback.vala"
		g_signal_emit (self, gpx_playback_signals[GPX_PLAYBACK_STATE_CHANGED_SIGNAL], 0, GPX_PLAYBACK_STATE_PAUSED);
#line 449 "gpx-playback.c"
	} else {
		GTimer* _tmp2_;
#line 107 "../gpx-viewer/libgpx/gpx-playback.vala"
		self->priv->timer = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 250, _gpx_playback_timer_callback_gsource_func, g_object_ref (self), g_object_unref);
#line 108 "../gpx-viewer/libgpx/gpx-playback.vala"
		_tmp2_ = self->priv->progress;
#line 108 "../gpx-viewer/libgpx/gpx-playback.vala"
		g_timer_continue (_tmp2_);
#line 109 "../gpx-viewer/libgpx/gpx-playback.vala"
		g_signal_emit (self, gpx_playback_signals[GPX_PLAYBACK_STATE_CHANGED_SIGNAL], 0, GPX_PLAYBACK_STATE_PLAY);
#line 460 "gpx-playback.c"
	}
}

void
gpx_playback_stop (GpxPlayback* self)
{
#line 114 "../gpx-viewer/libgpx/gpx-playback.vala"
	if (self->priv->timer > ((guint) 0)) {
#line 469 "gpx-playback.c"
		GTimer* _tmp0_;
		GTimer* _tmp1_;
#line 115 "../gpx-viewer/libgpx/gpx-playback.vala"
		g_debug ("gpx-playback.vala:115: stop playback\n");
#line 116 "../gpx-viewer/libgpx/gpx-playback.vala"
		g_source_remove (self->priv->timer);
#line 117 "../gpx-viewer/libgpx/gpx-playback.vala"
		self->priv->timer = (guint) 0;
#line 118 "../gpx-viewer/libgpx/gpx-playback.vala"
		_tmp0_ = self->priv->progress;
#line 118 "../gpx-viewer/libgpx/gpx-playback.vala"
		g_timer_stop (_tmp0_);
#line 119 "../gpx-viewer/libgpx/gpx-playback.vala"
		_tmp1_ = self->priv->progress;
#line 119 "../gpx-viewer/libgpx/gpx-playback.vala"
		g_timer_reset (_tmp1_);
#line 120 "../gpx-viewer/libgpx/gpx-playback.vala"
		g_signal_emit (self, gpx_playback_signals[GPX_PLAYBACK_STATE_CHANGED_SIGNAL], 0, GPX_PLAYBACK_STATE_STOPPED);
#line 488 "gpx-playback.c"
	}
#line 122 "../gpx-viewer/libgpx/gpx-playback.vala"
	g_signal_emit (self, gpx_playback_signals[GPX_PLAYBACK_TICK_SIGNAL], 0, NULL);
#line 492 "gpx-playback.c"
}

gint
gpx_playback_get_speedup (GpxPlayback* self)
{
	gint result;
#line 44 "../gpx-viewer/libgpx/gpx-playback.vala"
	result = self->priv->_speedup;
#line 44 "../gpx-viewer/libgpx/gpx-playback.vala"
	return result;
#line 503 "gpx-playback.c"
}

void
gpx_playback_set_speedup (GpxPlayback* self,
                          gint value)
{
#line 46 "../gpx-viewer/libgpx/gpx-playback.vala"
	gpx_playback_pause (self);
#line 47 "../gpx-viewer/libgpx/gpx-playback.vala"
	self->priv->_speedup = value;
#line 48 "../gpx-viewer/libgpx/gpx-playback.vala"
	gpx_playback_pause (self);
#line 45 "../gpx-viewer/libgpx/gpx-playback.vala"
	g_object_notify_by_pspec ((GObject *) self, gpx_playback_properties[GPX_PLAYBACK_SPEEDUP_PROPERTY]);
#line 518 "gpx-playback.c"
}

static void
g_cclosure_user_marshal_VOID__GPX_POINT (GClosure * closure,
                                         GValue * return_value,
                                         guint n_param_values,
                                         const GValue * param_values,
                                         gpointer invocation_hint,
                                         gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__GPX_POINT) (gpointer data1, gpointer arg_1, gpointer data2);
	register GMarshalFunc_VOID__GPX_POINT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 24 "../gpx-viewer/libgpx/gpx-playback.vala"
	g_return_if_fail (n_param_values == 2);
#line 24 "../gpx-viewer/libgpx/gpx-playback.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 24 "../gpx-viewer/libgpx/gpx-playback.vala"
		data1 = closure->data;
#line 24 "../gpx-viewer/libgpx/gpx-playback.vala"
		data2 = param_values->data[0].v_pointer;
#line 543 "gpx-playback.c"
	} else {
#line 24 "../gpx-viewer/libgpx/gpx-playback.vala"
		data1 = param_values->data[0].v_pointer;
#line 24 "../gpx-viewer/libgpx/gpx-playback.vala"
		data2 = closure->data;
#line 549 "gpx-playback.c"
	}
#line 24 "../gpx-viewer/libgpx/gpx-playback.vala"
	callback = (GMarshalFunc_VOID__GPX_POINT) (marshal_data ? marshal_data : cc->callback);
#line 24 "../gpx-viewer/libgpx/gpx-playback.vala"
	callback (data1, gpx_value_get_point (param_values + 1), data2);
#line 555 "gpx-playback.c"
}

static void
gpx_playback_class_init (GpxPlaybackClass * klass,
                         gpointer klass_data)
{
#line 24 "../gpx-viewer/libgpx/gpx-playback.vala"
	gpx_playback_parent_class = g_type_class_peek_parent (klass);
#line 24 "../gpx-viewer/libgpx/gpx-playback.vala"
	g_type_class_adjust_private_offset (klass, &GpxPlayback_private_offset);
#line 24 "../gpx-viewer/libgpx/gpx-playback.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_gpx_playback_get_property;
#line 24 "../gpx-viewer/libgpx/gpx-playback.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_gpx_playback_set_property;
#line 24 "../gpx-viewer/libgpx/gpx-playback.vala"
	G_OBJECT_CLASS (klass)->finalize = gpx_playback_finalize;
#line 24 "../gpx-viewer/libgpx/gpx-playback.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GPX_PLAYBACK_SPEEDUP_PROPERTY, gpx_playback_properties[GPX_PLAYBACK_SPEEDUP_PROPERTY] = g_param_spec_int ("speedup", "speedup", "speedup", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../gpx-viewer/libgpx/gpx-playback.vala"
	gpx_playback_signals[GPX_PLAYBACK_TICK_SIGNAL] = g_signal_new ("tick", GPX_TYPE_PLAYBACK, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__GPX_POINT, G_TYPE_NONE, 1, GPX_TYPE_POINT);
#line 24 "../gpx-viewer/libgpx/gpx-playback.vala"
	gpx_playback_signals[GPX_PLAYBACK_STATE_CHANGED_SIGNAL] = g_signal_new ("state-changed", GPX_TYPE_PLAYBACK, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__ENUM, G_TYPE_NONE, 1, GPX_PLAYBACK_TYPE_STATE);
#line 578 "gpx-playback.c"
}

static void
gpx_playback_instance_init (GpxPlayback * self,
                            gpointer klass)
{
	GTimer* _tmp0_;
#line 24 "../gpx-viewer/libgpx/gpx-playback.vala"
	self->priv = gpx_playback_get_instance_private (self);
#line 31 "../gpx-viewer/libgpx/gpx-playback.vala"
	_tmp0_ = g_timer_new ();
#line 31 "../gpx-viewer/libgpx/gpx-playback.vala"
	self->priv->progress = _tmp0_;
#line 32 "../gpx-viewer/libgpx/gpx-playback.vala"
	self->priv->track = NULL;
#line 33 "../gpx-viewer/libgpx/gpx-playback.vala"
	self->priv->timer = (guint) 0;
#line 36 "../gpx-viewer/libgpx/gpx-playback.vala"
	self->priv->first = NULL;
#line 42 "../gpx-viewer/libgpx/gpx-playback.vala"
	self->priv->_speedup = 50;
#line 600 "gpx-playback.c"
}

static void
gpx_playback_finalize (GObject * obj)
{
	GpxPlayback * self;
#line 24 "../gpx-viewer/libgpx/gpx-playback.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GPX_TYPE_PLAYBACK, GpxPlayback);
#line 127 "../gpx-viewer/libgpx/gpx-playback.vala"
	g_debug ("gpx-playback.vala:127: Destroying playback");
#line 31 "../gpx-viewer/libgpx/gpx-playback.vala"
	_g_timer_destroy0 (self->priv->progress);
#line 32 "../gpx-viewer/libgpx/gpx-playback.vala"
	_g_object_unref0 (self->priv->track);
#line 36 "../gpx-viewer/libgpx/gpx-playback.vala"
	_gpx_point_unref0 (self->priv->first);
#line 24 "../gpx-viewer/libgpx/gpx-playback.vala"
	G_OBJECT_CLASS (gpx_playback_parent_class)->finalize (obj);
#line 619 "gpx-playback.c"
}

static GType
gpx_playback_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GpxPlaybackClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gpx_playback_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GpxPlayback), 0, (GInstanceInitFunc) gpx_playback_instance_init, NULL };
	GType gpx_playback_type_id;
	gpx_playback_type_id = g_type_register_static (G_TYPE_OBJECT, "GpxPlayback", &g_define_type_info, 0);
	GpxPlayback_private_offset = g_type_add_instance_private (gpx_playback_type_id, sizeof (GpxPlaybackPrivate));
	return gpx_playback_type_id;
}

GType
gpx_playback_get_type (void)
{
	static volatile gsize gpx_playback_type_id__once = 0;
	if (g_once_init_enter (&gpx_playback_type_id__once)) {
		GType gpx_playback_type_id;
		gpx_playback_type_id = gpx_playback_get_type_once ();
		g_once_init_leave (&gpx_playback_type_id__once, gpx_playback_type_id);
	}
	return gpx_playback_type_id__once;
}

static void
_vala_gpx_playback_get_property (GObject * object,
                                 guint property_id,
                                 GValue * value,
                                 GParamSpec * pspec)
{
	GpxPlayback * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GPX_TYPE_PLAYBACK, GpxPlayback);
#line 24 "../gpx-viewer/libgpx/gpx-playback.vala"
	switch (property_id) {
#line 24 "../gpx-viewer/libgpx/gpx-playback.vala"
		case GPX_PLAYBACK_SPEEDUP_PROPERTY:
#line 24 "../gpx-viewer/libgpx/gpx-playback.vala"
		g_value_set_int (value, gpx_playback_get_speedup (self));
#line 24 "../gpx-viewer/libgpx/gpx-playback.vala"
		break;
#line 660 "gpx-playback.c"
		default:
#line 24 "../gpx-viewer/libgpx/gpx-playback.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../gpx-viewer/libgpx/gpx-playback.vala"
		break;
#line 666 "gpx-playback.c"
	}
}

static void
_vala_gpx_playback_set_property (GObject * object,
                                 guint property_id,
                                 const GValue * value,
                                 GParamSpec * pspec)
{
	GpxPlayback * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GPX_TYPE_PLAYBACK, GpxPlayback);
#line 24 "../gpx-viewer/libgpx/gpx-playback.vala"
	switch (property_id) {
#line 24 "../gpx-viewer/libgpx/gpx-playback.vala"
		case GPX_PLAYBACK_SPEEDUP_PROPERTY:
#line 24 "../gpx-viewer/libgpx/gpx-playback.vala"
		gpx_playback_set_speedup (self, g_value_get_int (value));
#line 24 "../gpx-viewer/libgpx/gpx-playback.vala"
		break;
#line 686 "gpx-playback.c"
		default:
#line 24 "../gpx-viewer/libgpx/gpx-playback.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../gpx-viewer/libgpx/gpx-playback.vala"
		break;
#line 692 "gpx-playback.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

